
% my vi mode

variable Cmode = "Vi-command",
	 Imode = "Vi-insert";


$1 = "Vi-command";
$2 = "Vi-insert";

!if (keymap_p(Cmode))
{
   make_keymap(Cmode);
   _for (1, 127, 1)
     {
        $3 = char(());
        undefinekey($3, $1);
     }
   _for ('1', '9', 1)
     {
        $3 = char(());
        definekey("digit_arg", $3, $1);
     }
   definekey("vi_previous_char",        "h", $1);
   definekey("vi_next_line",           "j", $1);
   definekey("vi_previous_line",       "k", $1);
   definekey("vi_next_char",            "l", $1);
   definekey("page_down",               "^F", $1);
   definekey("page_up",                 "^B", $1);
   definekey("vi_window_up",            "^E", $1);
   definekey("vi_window_down",          "^Y", $1);
   definekey("vi_window_half_up",       "^D", $1);
   definekey("vi_window_half_down",     "^U", $1);
%   definekey("delete_char_cmd",         "x",  $1);
   definekey("vi_delete",             "x",  $1);
   definekey("vi_insert",               "i", $1);
   definekey("vi_Insert",               "I", $1);
   definekey("vi_append",               "a", $1);
   definekey("vi_Append",               "A", $1);
   definekey("vi_kill_line",			"D",  $1);
   definekey("yank",					"P",  $1);
   definekey("vi_yank",					"y",  $1);
   definekey("undo",					"u",  $1);
   definekey("vi_return",				"^M",  $1);
   definekey("vi_goto_top_of_window",	"H",  $1);
   definekey("vi_goto_bottom_of_window", "L",  $1);
   definekey("vi_goto_center_of_window", "M",  $1);

   definekey("vi_delete",				"d", $1);
   definekey("vi_previous_char",        "^?", $1);
   definekey("vi_previous_char",        "^H", $1);
   definekey("redraw",					"z.", $1);
   definekey("beg_of_line",				"0", $1);
   definekey("vi_eol",					"$", $1);
   definekey("quoted_insert",			"^V", $1);
   definekey("search_backward",			"?", $1);
   definekey("search_forward",			"/", $1);
   definekey("vi_G",					"G", $1);
   definekey("vi_paste",				"p", $1);
   definekey("vi_paste",				"P", $1);

   definekey("beg_of_buffer",			"g", $1);
   definekey("skip_word",				"e", $1);

   definekey("bskip_word",				"b", $1);
#ifdef MSDOS
#ifdef PC98

#else
   definekey("previous_line_cmd",		"^@H",  $1);
   definekey("next_line_cmd",			"^@P",  $1);
   definekey("previous_char_cmd",		"^@K",  $1);
   definekey("next_char_cmd",			"^@M",  $1);
   definekey("delete_char_cmd",			"^@S",  $1);
#endif
#endif
%   definekey("beep",					"^[",  $1);
}

!if (keymap_p($2))
{
   make_keymap($2);
   _for (32, 127, 1)
     {
        $4 = char(());
%        undefinekey($4, $2);
        definekey("self_insert_cmd",  $4, $2);
     }
   undefinekey("^[", $2);
   undefinekey("^U", $2);

   definekey("vi_mode",         "^[", $2);
   definekey("quoted_insert",         "^V", $2);
   definekey("vi_backward_delete_char", "^?", $2);
   definekey("vi_backward_delete_char", "^H", $2);
}

define vi_beep()
{
   beep();
}

define vi_insert ()
{
   use_keymap($2);
   set_status_line("(Jed %v) Vi-insert: %b    (%m%a%n%o)  %p,%c   %t", 1);
}

define vi_mode ()
{
   use_keymap($1);
   set_status_line("(Jed %v) Vi-command: %b    (%m%a%n%o)  %p,%c   %t", 1);
%  set_status_line(" Jed Vi: %f    (%p)", 0);
   enable_top_status_line(0);
   !if(bolp())	go_left(1);
}

define vi_append()
{
   !if (eolp())
	 go_right(1);
	   
	   vi_insert();
}

define vi_Append()
{
   eol();
   vi_insert();
   
}

define vi_Insert()
{
   bol();
   skip_chars(" \t");

   vi_insert();
   
}

define vi_G()
{
   eob(); bol();
}

define vi_eol()
{
   eol();
   !if(bolp()) go_left(1);

}

define vi_previous_char1()
{
   !if(bolp()) {
	  go_left(1);
	  return 1;
   }
   else beep ();
   return 0;
}

define vi_previous_char()
{
   variable n = prefix_argument (1);

   while( n ) {
	  !if( vi_previous_char1()) return;
	  n--;
   }
}

define vi_next_char1()
{
   !if(eolp()) {
	  go_right (1);
	  if(eolp() and not (bolp())) {
		 go_left(1);
	  }
	  else
		return 1;
   }
   else beep ();
   return 0;
}

define vi_next_char()
{
   variable n = prefix_argument (1);

   while( n ) {
	  !if( vi_next_char1()) return;
	  n--;
   }
}

define vi_next_line()
{
   call("next_line_cmd");

   if(eolp())
	 !if(bolp())
	   go_left(1);
}

define vi_previous_line()
{
   call("previous_line_cmd");
   
   
%   variable n = prefix_argument (1);

%   go_up(n);
   if(eolp())
	 !if(bolp())
	   go_left(1);
}

define vi_return()
{
   go_down(1);
   skip_chars(" \t");
}


variable yank_buffer = "*vi_yank_buffer*";

define vi_yank_sub(sub_cmd)
{
   variable cbuf = whatbuf ();
   
   push_spot();
   setbuf(yank_buffer);
   erase_buffer ();
   setbuf (cbuf);

   if(sub_cmd == 1) bol();
   push_mark(); 1;
   eol();
   if(sub_cmd == 1)	go_right();

   copy_region(yank_buffer);

   pop_spot();
   message("yanked.");
}

define vi_yank()
{
   variable sub;

   sub = getkey();
   switch (sub)
	 { case  'y' : vi_yank_sub(1)}		% line
	 { case  '$' : vi_yank_sub(2)}		% eol
%	 { case  '' : }
	 {
		break
	 }
}

define vi_paste()
{
   variable cbuf = whatbuf ();
   variable yankbufline = 0;

   push_spot ();
   setbuf(yank_buffer);
   eob();
   yankbufline = what_line();
   setbuf(cbuf);
   pop_spot();

   !if(yankbufline)
	 {
		message("Not yanked.");
		vi_beep();
		return;
	 }
   if(yankbufline == 1)
	 {
		if(LAST_CHAR == 'p')
		  {
			 !if(eolp()) go_right(1);
		  }
		insbuf(yank_buffer);
	 }
   else
	 {
		 if(LAST_CHAR == 'p')
		  {
			 go_down(1);
		  }
		bol();
		insbuf(yank_buffer);
	 }
}

define vi_delete1()
{
   !if(eolp())
	 {
		deln(1);
		return 0;
	 }
   return 1;
}

define vi_delete ()
{
   variable n = prefix_argument (1);
   variable sub;
   variable cbuf = whatbuf ();

   setbuf(yank_buffer);
   erase_buffer();
   setbuf(cbuf);

   if(LAST_CHAR == 'd') sub = getkey();
   else sub = LAST_CHAR;
   _for(1, n, 1)
	 {
		switch (sub)
		  { case  'd' :
			 bol(); push_mark(); go_down(1);
			 call("kill_region");
			 setbuf(yank_buffer);
			 eob(); call("yank");
			 setbuf(cbuf);
		  }
		  { case  '.' or 'x' : if(vi_delete1()) break;}
		  { case  'w' : delete_word}
		  {
			 break
		  }
	 }
   !if(bolp())
	 {
		if(eolp()) go_left(1);
	 }
}

define vi_kill_line()
{
   if(eolp()) return;
   call("kill_line");
   !if(bolp()) go_left(1);
}

define vi_delete_x()
{
   ungetkey('.');
   vi_delete();
}

define vi_backward_delete_char()
{
   if(bolp()) return;
   call("backward_delete_char");
}

#ifdef 0
define vi_paste()
{
   variable sub;
   
}
#endif

%define vi_goto_center_of_window ()
%{
%   variable line, row;
%
%   goto_top_of_window ();
%   line = what_line ();
%   row = window_info ('r');
%   line = line + (row / 2);
%   goto_line (line);
%   bol ();
%}

% top line of window is 0.
define vi_what_window_line()
{
   variable ret, win_top_point, cur_point = what_line ();

   push_spot ();
   goto_top_of_window ();
   win_top_point = what_line ();
   pop_spot ();

   return cur_point - win_top_point;
}

define vi_window_up ()
{
   variable n = prefix_argument (1);
   variable col = what_column ();

   if(vi_what_window_line () < n) {
	  go_down(n);
	  eol ();
	  if(col <= what_column()) goto_column (col);
   }

   recenter (window_line() - n);
}

define vi_window_half_up () 
{
   variable n, halfrow;
   variable col = what_column ();

   n = window_info ('r') / 2;
   n = prefix_argument (n);
   if(vi_what_window_line () < n) {
	  go_down(n);
	  eol ();
	  if(col <= what_column()) goto_column (col);
   }
   recenter (window_line() - n);
}

define vi_window_down ()
{
   variable n = prefix_argument (1);
   variable col = what_column ();

   if((window_info('r') - vi_what_window_line () - 1) < n) {
	  go_up(n);
	  eol ();
	  if(col <= what_column()) goto_column (col);
   }
   recenter (window_line() + n);
}

define vi_window_half_down ()
{
   variable n;
   variable col = what_column ();

   n = window_info ('r') / 2;
   n = prefix_argument (n);
   if((window_info('r') - vi_what_window_line () - 1) < n) {
	  go_up(n);
	  eol ();
	  if(what_column() >= col) goto_column (col);
   }
   recenter (window_line() + n);
}

define vi_goto_top_of_window ()
{
   goto_top_of_window ();
   bol ();
}

define vi_goto_bottom_of_window ()
{
   goto_bottom_of_window ();
   bol ();
}

define vi_goto_center_of_window ()
{
   variable line, row;

   goto_top_of_window ();
   line = what_line ();
   row = window_info ('r');
   line = line + (row / 2);
   goto_line (line);
   bol ();
}


% vi_mode();
